;(function($) {
    $(document).ready(function() {
        $("a.lightbox").lightbox({minWidth: 600});
        $("input[type=checkbox].toggle").checkbox({toggle: true});

        $("input[type=checkbox].toggle").on('change', function() {
            var $chk = $(this);
            var req = $(this).closest('form').serialize();

            var is_en = this.checked;
            var domid = $chk.data('domid');
            var $btns = $('button.domain_' + domid);
            $btns.attr('disabled', 'disabled');

            var progcls = is_en ? 'toggle-progress-en' : 'toggle-progress-dis';

            $chk.checkbox('disable');
            $chk.after('<span class="toggle-progress ' + progcls + '"></span>');

            $.post("action.live.php", req)
             .done(function(data) {
                $chk.next('.toggle-progress').remove();
                $chk.after('<i class="fa fa-thumbs-up ' + (is_en ? 'en' : '') + '"></i>');
                setTimeout(function() {
                    reset_toggle($chk, is_en);
                }, 1000)
             })
             .fail(function() { console.log("Toggle request failed!"); });
        });

        function reset_toggle($chk, is_en) {
            $chk.next('.fa.fa-thumbs-up').remove();
            $chk.checkbox('enable');
            if (is_en) {
                var domid = $chk.data('domid');
                var $btns = $('button.domain_' + domid).removeAttr('disabled');
            }
        }

        $("button.purge").on('click', function(e) {
            e.stopPropagation();

            var $btn = $(this);
            $btn.attr('disabled', 'disabled');
            var reason = $btn.data('progress-text') != undefined ? $btn.data('progress-text') : "";

            $btn.data('orig-text', $btn.text());
            $btn.html('<span class="progress-circles"></span> ' + reason);

            var req = $(this).closest('form').serialize() + '&purge=true';
            $.post("action.live.php", req)
             .done(function(data) {
                $btn.html('<i class="fa fa-thumbs-up"></i>');
                setTimeout(function() {
                    reset_purge($btn);
                }, 1000)
             }).fail(function() { });

             return false;
        });

        function reset_purge($btn) {
            $btn.text($btn.data('orig-text'));
            var domid = $btn.data('domid');
            if ($('input[type=checkbox].toggle.domain_' + domid).is(':checked')) {
                $btn.removeAttr('disabled');
            }
        }

        $("button.devmode").on('click', function(e) {
            e.stopPropagation();

            var $btn = $(this);
            var status = $(this).closest('form').find('.en').val();

            if (status == 'on') {
                var new_status = 'off';
                var explain = 'Disabling, standby..';
                $btn.removeClass('en');
            } else {
                var new_status = 'on';
                var explain = 'Enabling, standby..';
                $btn.addClass('en');
            }

            $btn.attr('disabled', 'disabled');
            $(this).closest('form').find('input[name=en]').val(new_status);
            $btn.html('<span class="progress-circles"></span>');

            var req = $(this).closest('form').serialize() + '&toggle_devmode=true';
            $.post("action.live.php", req)
             .done(function(data) {
                $btn.html('<i class="fa fa-thumbs-up"></i>');
                setTimeout(function() {
                    reset_devmode($btn, new_status);
                }, 1000)

             })
             .fail(function() { console.log("Devmode request failed!"); });

             return false;
        });

        function reset_devmode($btn, status) {
            if (status == 'on') {
                $btn.text("Disable Development Mode").addClass("en");
            } else {
                $btn.text("Enable Development Mode").removeClass("en");
            }

            var domid = $btn.data('domid');
            if ($('input[type=checkbox].toggle.domain_' + domid).is(':checked')) {
                $btn.removeAttr('disabled');
            }
        }

    });
})(jQuery);

