var loader_html = '<div class="loader"><div>' + new Array(36).join('<p></p>') + '</div><span>Standby..</span></div>',
    enable_scrolling = true,
    last_response_len = false,
    submitted = false,
    cb_last


window.Dashboard = {'duration': get_cookie('rtduration') || 60}

function get_cookie(name) {
    return $.cookie(name)
}

function set_cookie(name, value) {
    $.cookie(name, value)
}

function create_toggle(class_name) {
    var lnel = $('.drawer-toggle.' + class_name), cookiename = 'cw_' + lnel.data('name')

    if (lnel.length == 0)
        return;

    lnel.on('click', function(e) {
        var el = $(this), is_shown = el.text() == el.data('hide-text')

        if (is_shown) {
            el.text(el.data('original-text'));
        } else {
            el.data('original-text', el.text());
            el.text(el.data('hide-text'));
        }

        el.closest('.toggle-body-inner').find('.toggle-content').toggleClass('expanded', !is_shown)
        $.cookie(cookiename, !is_shown)
    });

    if ($.cookie(cookiename) == 'true')
        lnel.click();
}

function update_log(data) {
    var last_update_ts = update_log_change_ts(data[0]);
    var this_filename = data[1];
    var response = data[2];
    var empty = data[3];
    var this_response;

    if (this_filename != last_known_filename || empty == '1') {
        last_response_len = false;
        last_known_filename = this_filename;
        $('#upgrade_log_output').text('');
        $('#last_known_filename').text(last_known_filename);
    }

    if ($('#upgrade_log_output').data('empty') == '1' && empty == '0') {
        last_response_len = false;
        $('#upgrade_log_output').text('');
        $('#upgrade_log_output').data('empty', '0');
    }

    if (empty == '1') {
        $('#upgrade_log_output').data('empty', '1');
    }

    if (last_response_len === false) {
        this_response = response;
        last_response_len = response.length;
    } else {
        this_response = response.substring(last_response_len);
        last_response_len = response.length;
    }

    if (enable_scrolling && this_response.length > 0) {
        $('#upgrade_log_output').append(this_response);
        $('#upgrade_log_output').scrollTop(10000);
    }

    update_log_change_ts();
}

function update_log_change_ts(ts) {
    var $el = $('#last_updated');
    if (ts == undefined) {
        ts = $el.data('last-updated');
    } else {
        $el.data('last-updated', ts);
    }

    ts = parseInt(ts) * 1000;
    if (ts == 0) {
        $el.text("forever ago.. something is wrong!");
    } else {
        $el.text(moment(new Date(ts)).fromNow() + '.');
    }
}

function remove_cls_error(e) {
    if ($(this).is('select') || (e.type == 'click' && $(this).data('click-rmerr'))) {
        $(this).toggleClass('error', false).parents('.form-label.desc.error').toggleClass('error', false);
    } else if (e.type != 'click') {
        $(this).toggleClass('error', false);
    }
}

function update_review_log() {
    if ($('#upgrade_log_output').length > 0) {
        $('#upgrade_log_output').scrollTop(10000);

        $('#toggle_scrolling').on('click', function(e) {
            $(this).toggleClass('active');
            if ($(this).hasClass('active')) {
                enable_scrolling = true;
                $(this).text('Disable scrolling');
            } else {
                enable_scrolling = false;
                $(this).text('Enable scrolling');
            }
            e.preventDefault();
        });

        setInterval(function () {
            xhr = $.ajax({
                type: 'GET',
                url: 'poll-update-log.php',
                async: true,
                dataType: 'json',
            }).success(update_log).error(function () { update_log_change_ts() });
        }, 750);

        last_response_len = $('#upgrade_log_output').data('initial-length');
        update_log_change_ts();
    }
}

function toggle_remove_active(cb, btn) {
    $(document).ready(function() {
        var $cbs = $(cb);
        var $btn = $(btn);
        $cbs.on('change', function() {
            $btn.toggleClass('inactive', $cbs.filter(':checked').length == 0);
        });
        $btn.toggleClass('inactive', $cbs.filter(':checked').length == 0);
    });
}

function toggle_redirect(name) {
        var en = $('#en_redir_' + name).val() != 'on';
        $('#redir_target_' + name).toggle(en);
        $('#en_redir_' + name).val(en ? 'on' : 'off');
        $('#toggle_redir_' + name).val(en ? 'Disable Redirect' : 'Enable Redirect').addClass('disable');
        $('#redir_target_' + name + ' input').focus();
}

function handle_submit(e, btn) {
    if (submitted == true && btn == undefined) {
        e.preventDefault()
        return false
    }

    if (btn == undefined)
        btn = $(this)

    var body = btn.closest('.handle_wrapper')

    body.children().toggle(false)
    body.append($(loader_html))
    $('.remodal-wrapper').exists(no_close_overlay)
    submitted = true
    unload_warning()
}

function unload_warning() {
    // delay handler assignment to avoid warning for in-flight form submissions
    setInterval(function() {
        window.onbeforeunload = function(e) {
            var retval = 'Your last request is still processing, are you sure?'
            if (submitted) {
                e.returnValue = retval
                return retval
            }
        }
    }, 50)
}

function no_close_overlay() {
    $('.remodal-wrapper').unbind('click.remodal')
    $(window).unbind('hashchange.remodal')
    $(document).unbind('keydown.remodal')
}

function handle_keydown(e) {
    if (!submitted)
        return false

    if (e.keyCode == 27 || e.keyCode == 37 || e.keyCode == 39) {
        e.keyCode = 0
        e.preventDefault()
        e.stopPropagation()
        return false
    }
}

function handle_hashchange(e) {
    if (submitted) {
        e.preventDefault()
        e.stopPropagation()
        return false
    }
}

function toggle_field_reverse(e) {
    var field = $(this).find('input[data-toggle]')

    if (!field.length || !field.is(':disabled'))
        return

    var toggle = field.data('toggle').split(':'),
        target = field.closest('form').find('.field.' + toggle[0])

    target.val(toggle[1])
    if (target.is('select'))
        target.dropdown('update')

    field.removeAttr('disabled')
    field.focus()
}

function toggle_field(e) {
    var field = $(this).is('select') ? $(this).find(':selected') : $(this),
        toggle = $(this).data('toggle').split(':'),
        target = $(this).closest('form').find('.field.' + toggle[0])

    if (field.length > 0) {
        target.attr('disabled', field.val() != toggle[1])
        setTimeout(function() { target.focus() }, 25)
    }
}

function toggle_class(e) {
    var btn = $(this),
        shown = false

    if (e == undefined)
        shown = $.cookie('toggle_advanced') == 'true'
    else
        shown = !btn.data('hidden')

    $('div.form-row.advanced').toggle(shown)
    $.cookie('toggle_advanced', shown)

    btn.data('hidden', shown)
    btn.toggleClass('is_shown', shown)
    btn.text(shown ? "Hide Advanced" : "Show Advanced")
}

jQuery.fn.exists = function(callback, args) {
    return $(this).length > 0 && callback.call(this, args) || false;
};

function setup_optin_overlay() {
    var addcol_input = $('textarea.manage_optins.add_domain'),
        addcol = addcol_input.closest('span'),
        delcol_input = $('select.manage_optins.select_del_domain'),
        delcol = $('.manage_optins.select.del_domain'),
        btn = $('button[type=submit].manage_optins'),
        act = $('form.manage_optins input.action')

    function mute_del() {
        delcol.toggleClass('mute', true)
        addcol.toggleClass('mute', false)
        btn.text('ADD')
        act.val('add')
    }

    function mute_add() {
        addcol.toggleClass('mute', true)
        delcol.toggleClass('mute', false)
        btn.text('REMOVE')
        act.val('del')
    }

    addcol.on('click', mute_del)
    addcol_input.on('focus active', mute_del)
    delcol.on('click', mute_add)
    delcol.find('button').on('click', mute_add)
    delcol_input.on('change', mute_add)

    mute_del()
}

(function($) {
    var prompts = new Array()

    $(document).ready(function() {
        $('form.handle_form').on('submit', handle_submit)
        window.addEventListener('keydown', handle_keydown)

        $('select').dropdown()
        $("input[type=radio]").checkbox()

        // $('.update_realtime select.rtduration').on('change', rtduration)
        $('button.toggle_advanced').on('click', toggle_class)

        $('.prompt.purge_cache.is_success').exists(no_close_overlay)

        $('select[data-toggle]').on('change', toggle_field)
        $('input[data-toggle]').parent().on('click', toggle_field_reverse)

        $('button.toggle_advanced').exists(toggle_class)

        $('button.confirm_save_configuration').on('click', function (e) {
            handle_submit(e, $(this))
            submitted = false
            $('form.save_configuration').submit()
        })

        $('form.save_configuration input').on('keydown', function(e) {
            if (e.keyCode == 13) {
                $('button.save_configuration').trigger('click')
                return false
            }
        })

        $("select").dropdown()
        $('.prompt.manage_optins').exists(setup_optin_overlay)

        $(document).on('opened', '.prompt', function() {
            var prompt = $(this), focus_field

            if (prompt.is('.purge_cache')) {
                focus_field = prompt.find('.field.pattern')
                if (!focus_field.is(':disabled')) {
                    focus_field.focus()
                    return
                }
            }

            focus_field = prompt.find('input[type=text]:first')

            if (focus_field.length == 0)
                focus_field = prompt.find('button.btn:first')

            if (focus_field.length > 0)
                focus_field.focus()
        })

        $(document).on('closing', '.prompt', function() {
            $(this).find('.alert').remove()
            $(this).find('.form-body.is_result')
                   .toggleClass('is_result is_success is_error', false)
        })

        $(document).on('opening', '.prompt', function () {
            prompts.push($(this))
        })

        $(document).on('closing', '.prompt', function () {
            prompts.pop()
        })

        $('.prompt.remodal-is-opened').each(function () {
            var prompt = $(this)
                defbtn = prompt.find('button.btn:first'),
                focus_field = prompt.find('input[type=text]:first')

            prompts.push(prompt)

            if (prompt.is('.purge_cache'))
                prompt.find('select').trigger('change')

            focus_field = prompt.find('input[type=text]:first')

            if (focus_field.length == 0)
                focus_field = prompt.find('button.btn:first')

            if (focus_field.length > 0)
                focus_field.focus()
        })

        $(document).on('closed', '.prompt.pattern_guide', function () {
            if (prompts.length > 0)
                prompts.pop().remodal().open()
        })

        $("i.rule-tooltip").tooltip({direction: "right", delay: 250})
        $(".helptip.bottom").tooltip({direction: "bottom", delay: 350})

        $('.show-more').on('click', function(e) {
            $(this).toggleClass('active').closest('.form-body-inner').find('.form-content').toggleClass('expanded')
            if ($(this).hasClass('active')) {
                $.cookie('xv-show-more', true)
                $(this).text('Hide Advanced Settings')
            } else {
                $.cookie('xv-show-more', false)
                $(this).text('Show Advanced Settings')
            }
            e.preventDefault()
        })

        $('label a.more').on('click', function(e) {
            var btn = $(this), parent = $(this).closest('label')
            btn.text(btn.text() == 'More' ? 'Hide' : 'More')
            parent.find('p.more').toggle()
            return false
        })

        if ($('.show-more').length > 0) {
            var open = $.cookie('xv-show-more')
            if (open == 'true')
                $('.show-more').toggleClass('active')
                               .closest('.form-body-inner')
                               .find('.form-content')
                               .toggleClass('expanded')
        }

        $('#toggle_redir_frontend').on('click', function() { toggle_redirect('frontend') })
        $('#toggle_redir_backend').on('click', function() { toggle_redirect('backend') })
        $('#toggle_redir_ratelimit').on('click', function() { toggle_redirect('ratelimit') })
        $('#toggle_redir_waf').on('click', function() { toggle_redirect('waf') })

        $('input, input[type=number], input[type=radio], input[type=checkbox], select').each(
            function() {
                var el = $(this),
                    val = el.is(':checkbox') ? el.is(':checked') : el.val()
                el.data('initial-value', val)
        })

        var sorted = $('table.sorted'),
            sortconf = {
                cssAsc: 'asc',
                cssDesc: 'desc',
                cssHeader: 'sort_by',
                headers: {0: {sorter: false}},
                sortList: [[1, 1]],
                dateFormat: 'yyyy/MM/dd'
            }

        if (sorted.length > 0) {
            var table = $(sorted[0]),
                defsort = [1, 1],
                name = 'cwsort_' + table.data('name')
                sort = get_cookie(name) ? get_cookie(name).split(",") : defsort

            sort = [parseInt(sort[0]), parseInt(sort[1])]

            if (isNaN(sort[0]) || isNaN(sort[1]))
                sort = defsort

            sortconf.sortList = [sort]

            if (page_name == 'exclusions')
                sortconf.headers[2] = {sorter: false}

            else if (page_name == 'rate-limiting')
                sortconf.headers[3] = {sorter: false}

            sortconf.textExtraction = function(n) {
                var sn = $(n).is('.target') ? $(n).find('.pattern') : $(n)
                return sn.text().replace(/[^0-9a-z\-.]/gi, '')
            }

            $('table.sorted').tablesorter(sortconf)

            $('table.cellstick tr').on('click', function(e) {
                if (e.target && e.target.type == 'checkbox')
                    return true

                $(':checkbox', this).trigger('click')
                return false
            })

            $('table.sorted th.sort_by').on('click', function(e) {
                var el = $(this),
                    name = 'cwsort_' + el.closest('table').data('name'),
                    order = el.hasClass('desc') ? 1 : 0
                set_cookie(name, "" + el.index() + "," + order)
            })
        }

        $('table .checkbox').on('click', function(e) {
            if (cb_last && e.shiftKey) {
                document.getSelection().removeAllRanges()
                var cbs = $(this).closest('table').find('.checkbox'),
                    si = cbs.index(this),
                    ei = cbs.index(cb_last),
                    cbs2 = cbs.slice(Math.min(si, ei) + 1,  Math.max(si, ei))
                    last = cb_last.find('input')

                cbs2.find('input').prop('checked', last.prop('checked'))
            }
            cb_last = $(this)
            return true
        })

        $('table').mousedown(function (e) {
            if (e.shiftKey) e.preventDefault()
        })
    })
})(jQuery)
