(function($, data) {
    var req, wait, poll, stale, abort, date,
        period = 5000

    var con = $('#status-dropdown'),
        pnd = con.find('div.pending'),
        sphere = $('#status_sphere'),
        el_varnish = con.find('.status.varnish'),
        el_backend = con.find('.status.backend'),
        el_xvhealth = con.find('.status.xvhealth'),
        el_xvstats = con.find('.status.xvstats'),
        el_xvbeat = con.find('.status.xvbeat')

    function ucfirst(str) {
        return str.replace(/\b[a-z]/g, function(c) { return c.toUpperCase() })
    }

    function update_status(d) {
        if (!d.success)
            return

        status = d.status

        if (!sphere.hasClass(d.status.sys_state)) {
            sphere.removeClass('okay warning error')
                  .addClass(d.status.sys_state)
        }

        pnd.find('p').text(d.status.vcl_status)
        pnd.removeClass('reload restart update current')
           .addClass(d.status.vcl_pending)

        var varnish_label = d.status.varnish_status ? 'running' : 'stopped',
            backend_label = d.status.backend_status ? 'running' : 'stopped',
            xvhealth_label = d.status.xvhealth_status ? 'running' : 'stopped',
            xvstats_label = d.status.xvstats_status ? 'running' : 'stopped',
            xvbeat_label = d.status.xvbeat_status ? 'running' : 'stopped'

        if (el_varnish.text().toLowerCase() != varnish_label)
            el_varnish.removeClass('stopped running').addClass(varnish_label)
                      .text(ucfirst(varnish_label))

        if (el_backend.text().toLowerCase() != backend_label)
            el_backend.removeClass('stopped running').addClass(backend_label)
                      .text(ucfirst(backend_label))

        if (el_xvhealth.text().toLowerCase() != xvhealth_label)
            el_xvhealth.removeClass('stopped running').addClass(xvhealth_label)
                      .text(ucfirst(xvhealth_label))

        if (el_xvstats.text().toLowerCase() != xvstats_label)
            el_xvstats.removeClass('stopped running').addClass(xvstats_label)
                      .text(ucfirst(xvstats_label))

        if (el_xvbeat.text().toLowerCase() != xvbeat_label)
            el_xvbeat.removeClass('stopped running').addClass(xvbeat_label)
                      .text(ucfirst(xvbeat_label))


        // var events = d.status.events
        // events.reverse()

        // for (var i in events) {
        //     var event = events[i],
        //         id = event.id,
        //         el = $('.events .event.' + id)

        //     if (el.length == 0) {
        //         console.log('append ', event)
        //     } else {
        //         console.log('found  ', id)
        //     }
        // }
    }

    poll = setInterval(function() {
        if (!wait && !abort) {
            wait = true
            req = $.getJSON('status.php')
                   .success(update_status).always(function() { wait = false })
        }
    }, period)

    $(window).on('unload beforeunload', function() {
        abort = true
        !poll || clearInterval(poll)
        !wait || req.abort()
    })

    $(window).on('visibilitychange', function() {
        if (stale && !document.hidden) {
            stale = false
            update_status()
        }
    })
})(jQuery);
